-- Es gibt viel Redundanz, da das durchlaufen von Listen Seiteneffekt-frei 
-- und mit Seiteneffekten vorliegen sollte. Die Seiteneffekte sollen nur in 
-- Kommandos auftreten. Der Seiteneffekt ist auf ein Element der Klasse 
-- beschrnkt. Es wird hier `cursor' genannt.


class MY_LIST[G]
inherit 
   MY_NODE[G]
	  rename 
		 make as make_my_node,
		 set_right as set_next,
		 right as next
	  undefine 
		 out
	  end;
   
   ANY
	  redefine
		 out -- , copy
	  end;
   
   
creation
   make

feature -- Attribute


count: INTEGER; -- wieviele Elemente sind es denn?

iterating: BOOLEAN; -- iterieren wir gerade durch die Liste?

feature -- Creation

   make is 
		 -- Neue Liste anlegen
		 -- benutze die Tatsache, da Variablen in Eiffel mit default-Werten 
		 -- initialiserit werden, INTEGER als 0, REAL als 0.0, BOOLEAN als 
		 -- False und Referenzen als Void
	  do
		 
	  ensure
		 list_is_empty: empty; -- neue Liste mu leer sein.
	  end;
   
  

feature -- Queries 

   empty : BOOLEAN is
	  do
		 Result := (count = 0);
	  ensure
		 no_element_if_empty: Result implies (count = 0);
	  end;

   has(element: like item): BOOLEAN is
		 -- Achtung es wird ein Kommando aufgerufen?  Somit kann es 
		 -- zu Seiteneffekten kommen, eventuell eine andere 
		 -- Implementierung bevorzugen
	  require
		 element_exists: element /= Void;
	  do
		 search(element);
		 Result := found;
	  ensure
		 not_off_implies_found: Result implies found;
	  end;


   
	  
feature -- searching   
   
   search(element: like item) is
	   -- `search' ist ein Kommando, es wird mit Seiteneffekt auf `cursor' 
	   -- gearbeitet. 
	  require
		 element_exits: element /= Void;
		 not_iterating:  not iterating;
	  do
		 
		 found := False;
		 if empty  then
			found := false;
		 else 
			go_first;
			-- `cursor' steht auf dem ersten Element
			if element = item then
			   found := True;
			else
			   -- es wird immer ein Element vor dem gesuchten Element 
			   -- gestoppt, da man dann das gesuchte Element leicht lschen 
			   -- kann indem man einfach den `cursor.next' auf das Element 
			   -- `next.next' setzen kann.
			   from 
			   until found or next = Void
			   loop
				  if next.item = element then
					 found := True;
				  else
					 go_next;
				  end;
			   end; -- from
			end;
		 end;
		 iterating := False;
	  ensure
		 found_impies_has: found implies has(element);
		 not_iterating: not iterating;
	  end;
		 
		 

   
feature -- iteration
   -- Design Entscheidung: Die Iteration arbeitet auf cursor und es 
   -- wird nur ein Iterator erlaubt.
   
   go_first is 
	  require
		 not_currently_iterating: not iterating;
	  do
		 set_cursor(first);
		 iterating := True;
	  ensure
		 cursor_is_on_first: not empty implies cursor.is_equal(first)  							 and then iterating;
		 empty_implies_cursor_is_void: empty implies cursor = Void;
	  end;
   
   go_next is
	  require
		 not_empty: not empty;
		 iterating: iterating;
	  do
		 set_cursor(next);
		 if cursor /= Void then
			iterating := True;
		 else
			iterating := False;
		 end;
	  ensure
		cursor_moved: old next = cursor;
		iterating_while_cursor_not_void: iterating implies cursor /= Void;
	  end;
   
   go_i_th(pos: INTEGER) is
	  require
		 valid_index: valid_index(pos);
		 not_currently_iterating: not iterating;
	  local 
		 i : INTEGER;
	  do
		 from 
			i := pos;
			go_first;
		 invariant
			i >= 0 and then i <= pos + 1
		 variant
			i_decreases: i
		 until i = 0
		 loop
			i := i - 1;
			if i > 0 then
			   go_next;
			end;
		 end;
		 iterating := False;
	  ensure
		 not_iterating: not iterating;
		 proper_item: item = i_th(pos).item; 
		 proper_next:  next = i_th(pos).next;
	  end;

   

feature -- Elemente einfgen, lschen

   new_element: like Current;

   insert_first(new_entry: G) is
	  require
		 new_entry_exits: new_entry /= Void; -- keine leeren Eintrge erlauben
		 not_currently_iterating: not iterating;
	  do
		 new_element := new_node(new_entry);
		 if count = 1 then 
			 -- `new_element' ist der einzig Mgliche Eintrag
			first := new_element;
			last := new_element;
		 else
			new_element.set_next(first);
			first := new_element;
		 end;
	  ensure
		 inserted: has(new_entry) 
				   and then occurences(new_entry) 
				= old occurences(new_entry) + 1; 
		 new_element_at_front: new_element.is_equal(first);
		 count_adapted: count = old count + 1;
	  end;
   
   insert_last(new_entry: G) is
	  require
		 new_entry_exits : new_entry /= Void;
		 not_currently_iterating: not iterating;
	  do
		 new_element := new_node(new_entry);
		 if count = 1 then
			first := new_element;
			last := new_element;
		 else
			last.set_next(new_element);
			last := new_element;
		 end;
	  ensure
		 inserted: has(new_entry) and then occurences(new_entry) 
				= old occurences(new_entry) + 1; 
		 new_element_is_last: last.is_equal(new_element);
		 count_adapted: count = old count + 1;
	  end;

   insert_after(new_entry: G; pos: INTEGER) is
		 -- Element nach `pos' einfuegen, man kann sich berlegen ob man 
		 -- vielleicht pos <=0 als einfgen am Anfang ansehen will.
	  require
		 new_entry_exists : new_entry /= Void;
		 valid_pos: valid_index(pos);
		 not_currently_iterating: not iterating;
	  do
		 if pos = count then
			insert_last(new_entry);
		 else
			go_i_th(pos);
			new_element := new_node(new_entry);
			new_element.set_next(next);
			cursor.set_next(new_element);
		 end;
	  ensure
		 inserted: has(new_entry) and then (occurences(new_entry) 
											= old occurences(new_entry) + 1); 
		 proper_pos: i_th(pos+1).item.is_equal(new_entry);
		 count_adapted: count = old count + 1;
	  end;

   remove(element: like item) is
	  require
		 element_exits: element /= Void;
		 currently_not_iterating: not iterating;
		 not_empty: not empty;
	  do
		 search(element);
		 if found then
			remove_current;
		 else
			io.put_string("element : "); print(element);
			io.put_string(" not found. ");
		 end;
	  ensure
		 found implies occurences(element) = old occurences(element) - 1;
	  end;

   remove_all_of(element: like item) is
	  require
		 element_exists: element/= Void;
	  local 
		 it: like Current;
	  do
		 it := clone(Current);
		 Current.wipe_out;
		 from it := it.first;
		 until it = Void
		 loop
			if it.item /= element then
			   Current.insert_last(it.item);
			end;
			it := it.next;
		 end;
	  ensure
		 all_removed: not has (element);
	  end;

   
   occurences (element: like item): INTEGER is 
		 -- wie oft gibt es denn `element' in der Liste?
	  local
		 it: like Current;
	  do
		 from it := first;
		 until it = Void
		 loop
			if it.item = element then
			   Result := Result + 1;
			end;
			it := it.next;
		 end;
	  ensure
		 not_iterating: not iterating;
	  end;


   wipe_out is
	  -- wie lschen eine ganze Liste einfach indem wir die Werte 
	  -- auf Anfangswert zurcksetzen, da wir GC haben brauchen wir uns um 
	  -- nichts weiter zu kmmern.
	  do
	     first := Void;
		 last := Void;
		 count := 0;
		 iterating := False;
		 cursor := Void;
	  ensure
		 cleared: first = Void; last = Void; cursor = Void; 
				  count = 0; 
				  iterating = False;
	  end;


feature -- Arbeiten mit Listen

   append(other: like Current) is
	  -- `other' wird nicht verndert
	  require
		 other_exits : other /= Void and then not other.empty;
	  local
		 l: like Current;
	  do
		 l := deep_clone(other);
		 if first = Void then
			first := other.first;
			last := other.last;
			count := other.count;
		 else
			count := count + other.count;
			last.set_next(l.first);
			last := l.last;
		 end;
	  ensure
		 count_adapted: count = old count + other.count;
		 proper_first: old first = Void implies first = other.first;
					   old first /= Void implies first = old first;
		  proper_last: last = other.last;
	  end;

   slice (lower, upper : INTEGER): like Current is
	  require
		 lower_less_than_upper: lower <= upper;
		 lower_valid: valid_index(lower);
	  local
		 i : INTEGER;
		 save_cursor : like Current;
		 int_upper: INTEGER;
	  do
		 !!Result.make;
		 int_upper := upper;
		 if int_upper > count then
			int_upper := count + 1;
		 end;
		 save_cursor := cursor;
		 from
			i := lower;
			go_i_th(i);
		 invariant
			i_in_bound: i >= lower and then i<= upper
		 variant
			i_moves:  int_upper - i
		 until i = int_upper
		 loop
			Result.insert_last(item);
			go_next;
			i := i + 1;
		 end;
		 cursor := save_cursor;
	  end;
   
		 

feature -- ntzliche Abfragen

   valid_index (index:INTEGER): BOOLEAN is
	  do
		 Result := (index >= 1) and then (index <= count);
	  ensure
		 index_contraint: Result = ((index >= 1) 
									and then (index <= count));
	  end;


			
   i_th(pos: INTEGER): like Current is 
		 -- wie `go_i_th' jedoch ohne Seiteneffekte
	  require
		 valid_pos: valid_index(pos);
	  local
		 it: like Current;
		 i : INTEGER;
	  do
		 from i := pos;
			it := first;
		 invariant
			i >= 0 and then i <= pos
		 variant
			i_decreases: i
		 until i = 0
		 loop
			i := i - 1;
			if i > 0 then
			   it := it.next;
			end;
		 end;
		 Result := clone(it);
	  ensure
		 cursor_unchanged: Current.is_equal(old Current);
	  end;


feature -- Ausgabe
   

   out : STRING is
		 -- Ausgabe einer Liste, habe mich dafr entschieden es so aussehen 
		 -- zu lassen: `(Element1, Element2, Element3, ... )'
	  do
		 -- save_excursion;
		 !!Result.make(50);
		 Result.append("(");
		 from go_first
		 until cursor = Void
		 loop
			Result.append(item.out); 
			if next /= Void then
			   Result.append(", ");
			end;
			go_next;
		 end;
		 Result.append(")%N");
		 --restore_excursion;
	  end;

	 
		 
feature {MY_LIST} -- Implementierungdetails

   first, last: like Current; -- Anfang der Liste, Ende der Liste

   new_node(item_val: like item): like Current is
	  -- error Handling dazu?
	  do
		 !!Result.make;
		 Result.set_item(item_val);
		 Result.set_next(Void);
		 count := count + 1;
	  ensure then
		 proper_item: Result.item.is_equal(item_val);
		 next_is_void: Result.next = Void;
		 count_adapted: count = old count + 1 ;
	  end;

feature {MY_LIST}
   -- setzen der diversen Attribute, ist in einer Klasse nicht notwendig 
   -- da man hier auch eine direkt-zuweisung vornehmen kann, da man nie 
   -- wei was noch kommt, sehe ich hier einfach mal Mglichkeit vor
   set_cursor(new_val: like Current) is
	  do
		 cursor:= new_val;
		 if cursor /= Void then
			set_item(cursor.item);
			set_next(cursor.next);
		 else
			set_item(default_item);
			set_next(Void);
		 end;
	  ensure
		 cursor_set: cursor = new_val;
	  end;
   

feature {NONE}
cursor: like Current; 
-- aktuelle Position in der Liste auf diesem Element 


found: BOOLEAN; 
-- Wenn ein `search' erfolgreich war, ist `found' = True,und `cursor' steht 
-- entweder auf dem ersten Element oder genau ein Element vor dem gefundenen.

remove_current  is
		 -- Element aus der Liste entfernen 
	     -- ACHTUNG: Es wird nur das erste auftretende Element gelscht.
	  
	  require
		 cursor_exits: cursor /= Void;
		 found: found;
	  do
		 if cursor = first  then 
			   -- cursor steht auf dem ersten Element
			   first := first.next;
			   set_cursor(first);
		 else
			-- cursor steht ein Element vor dem gesuchten Eintrag
			if next = last then
				  -- vor dem letzten Element? Dann ist das Ende der Liste 
				  -- erreicht, wir mssen dementsprechend anpassen.
				  cursor.set_next(Void);
				  last := cursor;
			else
			   -- einfachster Fall, wir sind mitten in der Liste, wir 
			   -- brauchen nur das nchste Element zu berspringen
			   cursor.set_next(next.next);
			end;
		 end;
		 count := count -1;
	  ensure
		 count_adapted: cursor /= Void implies  count = old count - 1;
	  end;

   
   
   
invariant
   empty_invariant: empty implies count = 0;
   i_th_1_is_first: (count >= 1) implies i_th(1).is_equal(first);
   i_th_count_is_last: (count >= 1) implies i_th(count).is_equal(last);
   count_1_implies_first_is_equal_last: (count = 1) implies first.is_equal(last);
   count_positive: count >=0;
   
   
end --class MY_LIST
